package com.perforce.workshop.tjuricek.p4oauth

import org.gradle.api.DefaultTask

/**
 * Just some common methods used by both start and stop tasks.
 */
abstract class P4OAuthTask extends DefaultTask {

    File getP4OAuthJarFile() {
        return project.file("../build/libs/p4oauth.jar")
    }

    boolean isInitialized() {
        return p4OAuthWorkDir.exists()
    }

    boolean isRunning() {
        if (pidFile.exists()) {

            logger.info("checking if process is running using `ps aux`")

            def pid = pidFile.text.trim()

            def proc = "ps aux".execute()

            proc.waitFor()
            if (proc.exitValue() != 0) {
                throw new IllegalStateException("ps aux failed with exit code "
                        + proc.exitValue() + "\n" + proc.errorStream.text)
            }

            def psOut = proc.inputStream.text
            logger.info("output of ps: " + psOut)

            return psOut.contains(pid)
        }
        return false;
    }

    File getP4OAuthWorkDir() {
        return project.file("${project.buildDir}/p4oauth");
    }

    File getPidFile() {
        return new File(p4OAuthWorkDir, "pid")
    }

}
