package com.perforce.workshop.tjuricek.p4oauth

import org.gradle.api.tasks.TaskAction

import java.lang.reflect.Field

/**
 */
class StartTestServerTask extends TestServerTask {

    @TaskAction
    def startTestServer() {
        if (running) {
            setDidWork(false)
            return;
        }

        if (!testServerDir.exists()) {
            testServerDir.mkdirs()
        }

        File log = new File(testServerDir, "log");

        String cmd = "java -jar ${testServerJar.absolutePath} " +
                "${project.extensions.p4oauth.testServerPort} " +
                "${project.buildDir}/keystore > " +
                "${log.absolutePath}"

        logger.info("Executing ${cmd}")

        Process process = cmd.execute()

        Field f = process.getClass().getDeclaredField("pid");
        f.setAccessible(true)
        int pid = f.getInt(process);

        getPidFile().write("${pid}");
    }

    File getTestServerJar() {
        return project.file("test_server/build/libs/test_server.jar")
    }
}
