package com.perforce.workshop.tjuricek.p4oauth.config;

/**
 */
public class PerforceConfig {

    private boolean ssl = false;
    private String hostname = "localhost";
    private int port = 1666;

    public boolean isSsl() {
        return ssl;
    }

    public void setSsl(boolean ssl) {
        this.ssl = ssl;
    }

    public String getHostname() {
        return hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        PerforceConfig that = (PerforceConfig) o;

        if (port != that.port) return false;
        if (ssl != that.ssl) return false;
        if (hostname != null ? !hostname.equals(that.hostname) : that.hostname != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = (ssl ? 1 : 0);
        result = 31 * result + (hostname != null ? hostname.hashCode() : 0);
        result = 31 * result + port;
        return result;
    }

    @Override
    public String toString() {
        return "PerforceConfig{" +
                "ssl=" + ssl +
                ", hostname='" + hostname + '\'' +
                ", port=" + port +
                '}';
    }
}
