package com.perforce.workshop.tjuricek.p4oauth.services;

/**
 * Encapsulate responses to the authenticateCodeResult method.
 */
public class CodeResult {
    private String code = null;
    private CodeError error = null;

    public static CodeResult error(CodeError err) {
        CodeResult result = new CodeResult();
        result.setError(err);
        return result;
    }

    public static CodeResult code(String code) {
        CodeResult result = new CodeResult();
        result.setCode(code);
        return result;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public CodeError getError() {
        return error;
    }

    public void setError(CodeError error) {
        this.error = error;
    }

    public boolean hasError() {
        return this.error != null;
    }
}
